> ## Documentation Index
> Fetch the complete documentation index at: https://docs.ycloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update WABA automatic creative optimizations

> Partially updates automatic creative optimization feature enrollment for a WhatsApp Business Account.

Only submitted feature keys are updated. This endpoint does not persist feature enrollment locally and does not check whether the WABA has completed Meta MM Lite / ACO onboarding before forwarding the request to Meta.



## OpenAPI

````yaml /openapi/endpoints/ycloud-api-v2.yaml patch /whatsapp/businessAccounts/{wabaId}/automatic-creative-optimizations
openapi: 3.0.0
info:
  description: >-
    The [YCloud](https://ycloud.com) API is organized around
    [REST](https://en.wikipedia.org/wiki/Representational_state_transfer). Our
    API is designed to have predictable, resource-oriented URLs, return
    [JSON](https://www.json.org) responses, and use standard HTTP response codes
    and verbs.
  version: v2
  title: YCloud API
  termsOfService: https://ycloud.com/terms-service
  contact:
    email: service@ycloud.com
servers:
  - url: https://api.ycloud.com/v2
    description: Base URL
security:
  - api_key: []
tags:
  - name: Balance
  - name: Contacts
  - name: Custom Events
  - name: Emails
  - name: SMS
  - name: Unsubscribers
  - name: Verify
  - name: Voices
  - name: Webhook Endpoints
  - name: WhatsApp Business Accounts
  - name: WhatsApp Inbound Messages
  - name: WhatsApp Media
  - name: WhatsApp Messages
  - name: WhatsApp Blocked Users
  - name: WhatsApp Groups
  - name: WhatsApp Calling
  - name: WhatsApp Phone Numbers
  - name: WhatsApp Templates
  - name: WhatsApp Flows
  - name: Meta Business Agent
  - name: WhatsApp Group Messages
externalDocs:
  description: Homepage
  url: https://ycloud.com
paths:
  /whatsapp/businessAccounts/{wabaId}/automatic-creative-optimizations:
    patch:
      tags:
        - WhatsApp Business Accounts
      summary: Update WABA automatic creative optimizations
      description: >-
        Partially updates automatic creative optimization feature enrollment for
        a WhatsApp Business Account.


        Only submitted feature keys are updated. This endpoint does not persist
        feature enrollment locally and does not check whether the WABA has
        completed Meta MM Lite / ACO onboarding before forwarding the request to
        Meta.
      operationId: whatsapp_waba-update-automatic-creative-optimizations
      parameters:
        - name: wabaId
          in: path
          description: WhatsApp Business Account ID.
          required: true
          schema:
            type: string
            example: whatsapp-business-account-id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationUpdateRequest
      responses:
        '200':
          description: >-
            Successfully updated submitted automatic creative optimization
            features.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/WhatsappAutomaticCreativeOptimizationUpdateResponse
        '400':
          description: >-
            One or more request parameters are invalid, or Meta returned an
            error for the WABA automatic creative optimization update.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '403':
          description: You have no access to the requested WABA.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
components:
  schemas:
    WhatsappAutomaticCreativeOptimizationUpdateRequest:
      type: object
      required:
        - creativeOptimizationFeatures
      properties:
        creativeOptimizationFeatures:
          type: object
          description: >-
            A non-empty map of automatic creative optimization feature
            enrollment values. Only submitted features are updated.


            Supported feature keys:

            - `image_brightness_and_contrast`

            - `image_touchups`

            - `add_text_overlay`

            - `image_animation`

            - `image_background_gen`

            - `auto_promotion_tag`

            - `text_extraction_for_headline`

            - `text_extraction_for_tap_target`

            - `product_extensions`

            - `text_formatting_optimization`

            - `hyperlink_formatting`

            - `image_banner`

            - `image_end_card`

            - `dynamic_cta_text`
          minProperties: 1
          properties:
            image_brightness_and_contrast:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            image_touchups:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            add_text_overlay:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            image_animation:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            image_background_gen:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            auto_promotion_tag:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            text_extraction_for_headline:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            text_extraction_for_tap_target:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            product_extensions:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            text_formatting_optimization:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            hyperlink_formatting:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            image_banner:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            image_end_card:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
            dynamic_cta_text:
              $ref: >-
                #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
          additionalProperties: false
          example:
            image_brightness_and_contrast: OPT_IN
            image_touchups: OPT_OUT
    WhatsappAutomaticCreativeOptimizationUpdateResponse:
      type: object
      properties:
        wabaId:
          type: string
          description: WhatsApp Business Account ID returned by Meta.
          example: whatsapp-business-account-id
        creativeOptimizationFeatures:
          type: object
          description: >-
            The submitted feature enrollment values for PATCH responses, or
            current feature enrollment values for GET responses.
          additionalProperties:
            $ref: >-
              #/components/schemas/WhatsappAutomaticCreativeOptimizationEnrollStatus
          example:
            image_brightness_and_contrast: OPT_IN
            image_touchups: OPT_OUT
    ErrorResponse:
      type: object
      required:
        - error
      properties:
        error:
          $ref: '#/components/schemas/Error'
          description: >-
            Contains the error code and human-readable message for the API
            error.
    WhatsappAutomaticCreativeOptimizationEnrollStatus:
      type: string
      description: Automatic creative optimization feature enrollment status.
      enum:
        - OPT_IN
        - OPT_OUT
    Error:
      type: object
      required:
        - status
        - code
      properties:
        status:
          type: integer
          format: int32
          pattern: '[45]\d{2}'
          description: >-
            HTTP status code, [RFC 7231, Section
            6](https://datatracker.ietf.org/doc/html/rfc7231#section-6). It
            conveys the HTTP status code used for the convenience of the
            consumer.
          example: 404
        code:
          type: string
          description: >-
            One of a server-defined error codes. Some `4xx` errors that could be
            handled programmatically include an error code that briefly explains
            the error reported.
          example: NOT_FOUND
        message:
          type: string
          description: >-
            A human-readable representation of the error. It is intended as an
            aid to developers and is not suitable for exposure to end users.
          example: The requested resource does not exist.
        target:
          type: string
          description: The target of the error.
          example: ''
        docUrl:
          type: string
          description: A URL to more information about the error.
          example: ''
        requestId:
          type: string
          description: >-
            Each API request has an associated request ID. It conveys the
            response header `YCloud-Request-ID` used for the convenience of the
            consumer.
          example: req_1KjtKI80IKoaJNa6n6p
        whatsappApiError:
          $ref: '#/components/schemas/WhatsappApiError'
          description: >-
            The original error object returned by WhatsApp. See [Handling
            Errors](https://developers.facebook.com/docs/graph-api/guides/error-handling),
            [Cloud API Error
            Codes](https://developers.facebook.com/docs/whatsapp/cloud-api/support/error-codes).


            Note: This field is returned if we tried to request the WhatsApp
            Business API and got an error response.
        metaBusinessAgentApiError:
          $ref: '#/components/schemas/MetaBusinessAgentApiError'
          description: >-
            Sanitized upstream details returned when a Meta Business Agent
            request fails.
    WhatsappApiError:
      type: object
      description: >-
        The original error object returned by WhatsApp. See [Handling
        Errors](https://developers.facebook.com/docs/graph-api/guides/error-handling),
        [Cloud API Error
        Codes](https://developers.facebook.com/docs/whatsapp/cloud-api/support/error-codes).
      required:
        - message
        - code
      properties:
        message:
          type: string
          description: A human-readable description of the error.
          example: HSM Template creation failed
        code:
          type: string
          description: An error code.
          example: 200002
        type:
          type: string
          description: Error type.
          example: OAuthException
        is_transient:
          type: boolean
          description: Whether the error is transient.
          example: false
        error_subcode:
          type: string
          description: Additional code about the error.
          example: 2388109
        error_user_msg:
          type: string
          description: >-
            The message to display to the user. The language of the message is
            based on the locale of the API request.
          example: This message template cannot be created.
        error_user_title:
          type: string
          description: >-
            The title of the dialog, if shown. The language of the message is
            based on the locale of the API request.
          example: Message Cannot Be Submitted
        fbtrace_id:
          type: string
          description: >-
            Internal support identifier. When reporting a bug related to a Graph
            API call, include the fbtrace_id to help us find log data for
            debugging.
          example: AVGjJ7ia2zJkrHG
        error_data:
          description: >-
            Additional data about the error. A string or map.

            - For template APIs, this field is a string describing the reason
            for the error.

            - For message APIs, this field is a map with property `details`
            describing the reason for the error.
          oneOf:
            - type: string
            - type: object
              additionalProperties: true
    MetaBusinessAgentApiError:
      type: object
      description: Sanitized details from a failed Meta Business Agent upstream request.
      properties:
        title:
          type: string
        detail:
          type: string
        type:
          type: string
        status:
          type: integer
          format: int32
        requestId:
          type: string
  securitySchemes:
    api_key:
      type: apiKey
      name: X-API-Key
      in: header

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.